// ShapesView.cpp : implementation of the CShapesView class
//

#include "stdafx.h"
#include "Shapes.h"

#include "ShapesDoc.h"
#include "ShapesView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShapesView

IMPLEMENT_DYNCREATE(CShapesView, CView)

BEGIN_MESSAGE_MAP(CShapesView, CView)
	//{{AFX_MSG_MAP(CShapesView)
	ON_COMMAND(ID_SHAPES_CIRCLE, OnShapesCircle)
	ON_COMMAND(ID_SHAPES_RHOMB, OnShapesRhomb)
	ON_COMMAND(ID_SHAPES_SQUARE, OnShapesSquare)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShapesView construction/destruction

CShapesView::CShapesView()
{
	m_iCurrentShape = 0;	//   
}

CShapesView::~CShapesView()
{
}

BOOL CShapesView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CShapesView drawing

void CShapesView::OnDraw(CDC* pDC)
{
	CShapesDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//   
	for (int i=0; i<pDoc->m_v.size(); i++) {
		pDoc->m_v[i]->Draw(pDC);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CShapesView printing

BOOL CShapesView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CShapesView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CShapesView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CShapesView diagnostics

#ifdef _DEBUG
void CShapesView::AssertValid() const
{
	CView::AssertValid();
}

void CShapesView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CShapesDoc* CShapesView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CShapesDoc)));
	return (CShapesDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShapesView message handlers

void CShapesView::OnShapesCircle() 
{
	m_iCurrentShape = 0;
}

void CShapesView::OnShapesSquare() 
{
	m_iCurrentShape = 1;
}

void CShapesView::OnShapesRhomb() 
{
	m_iCurrentShape = 2;
}

void CShapesView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CShapesDoc* pDoc = GetDocument();

	//   
	Shape* pShape = CreateShape(m_iCurrentShape, point);

	pDoc->m_v.push_back(pShape);	//   

	pDoc->UpdateAllViews(NULL);

	CView::OnLButtonDown(nFlags, point);
}

void CShapesView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CShapesDoc* pDoc = GetDocument();

	// TODO   
	
	CView::OnRButtonDown(nFlags, point);
}
